// The rule has the following states:
//  0 background
//  1 stream moving northwest
//  2 stream moving northeast
//  3 stream moving southeast
//  4 stream moving southwest
//  5 .. 6 gate posts
//  7 .. 22 gate selectors

import java.awt.*;
import javax.swing.*;
import java.io.*;

class DiagonalParticleStreamsRule extends Rule
{
  private int NW;
  private int N;
  private int NE;
  private int W;
  private int C;
  private int E;
  private int SW;
  private int S;
  private int SE;

  private int v;

  public DiagonalParticleStreamsRule(JFrame mainFrame, SquareCell squareCell)
  {
    super(mainFrame, squareCell);
    this.mainFrame = mainFrame;
    this.squareCell = squareCell;
  }

  public void setNewRule()
  {
  }

  public void setOptions()
  {
  }

  public void setDefault()
  {
  }

  public void changeRule()
  {
  }

  public void writeRule(PrintWriter pw)
  {
    pw.println("#Rule = Diagonal Particle Streams");
  }

  public void readRule(BufferedReader br)
  {
  }

  public boolean Gate()
  {
    if ((SW == 5) && (S >= 7) && (S <= 22))
    {
      v = lookup(NW, W, S - 7) * 3;
      return true;
    }
    else if ((NW == 6) && (N >= 7) && (N <= 22))
    {
      v = lookup(W, SW, N - 7) * 2;
      return true;
    }
    else if ((NW == 5) && (W >= 7) && (W <= 22))
    {
      v = lookup(NE, N, W - 7) * 4;
      return true;
    }
    else if ((NE == 6) && (E >= 7) && (E <= 22))
    {
      v = lookup(N, NW, E - 7) * 3;
      return true;
    }
    else if ((NE == 5) && (N >= 7) && (N <= 22))
    {
      v = lookup(SE, E, N - 7);
      return true;
    }
    else if ((SE == 6) && (S >= 7) && (S <= 22))
    {
      v = lookup(E, NE, S - 7) * 4;
      return true;
    }
    else if ((SE == 5) && (E >= 7) && (E <= 22))
    {
      v = lookup(SW, S, E - 7) * 2;
      return true;
    }
    else if ((SW == 6) && (W >= 7) && (W <= 22))
    { 
      v = lookup(S, SE, W - 7);
      return true;
    }
    return false;
  }

  public int lookup(int a, int b, int i)
  {
    int[][] t = {{0, 0, 0, 0},
                 {0, 0, 0, 1},
                 {0, 0, 1, 0},
                 {0, 0, 1, 1},
                 {0, 1, 0, 0},
                 {0, 1, 0, 1},
                 {0, 1, 1, 0},
                 {0, 1, 1, 1},
                 {1, 0, 0, 0},
                 {1, 0, 0, 1},
                 {1, 0, 1, 0},
                 {1, 0, 1, 1},
                 {1, 1, 0, 0},
                 {1, 1, 0, 1},
                 {1, 1, 1, 0},
                 {1, 1, 1, 1}};
    int j;
    if (a == 0)
      j = 0;
    else
      j = 2;
    if (b != 0)
      j++;
    return t[i][j];
  }
  
  public int step(int r, int c)
  {
    NW = squareCell.getNeighbor(r - 1, c - 1);
    N  = squareCell.getNeighbor(r - 1, c    );
    NE = squareCell.getNeighbor(r - 1, c + 1);
    W  = squareCell.getNeighbor(r    , c - 1);
    C  = squareCell.getNeighbor(r    , c    );
    E  = squareCell.getNeighbor(r    , c + 1);
    SW = squareCell.getNeighbor(r + 1, c - 1);
    S  = squareCell.getNeighbor(r + 1, c    );
    SE = squareCell.getNeighbor(r + 1, c + 1);
    if ((C >= 5) && (C <= 22))
      return C;
    if (Gate())
      return v;
    if (C == 0)
      if ((SE == 1) && (NE != 4))
        return 1;
      else if (SW == 2)
        return 2;
      else if (NW == 3)
        return 3;
      else if (NE == 4)
        return 4;
    if ((C == 1) && (SE == 1))
      return 1;
    if ((C == 2) && (SW == 2))
      return 2;
    if ((C == 3) && (NW == 3))
      return 3;
    if ((C == 4) && (NE == 4))
      return 4;
    return 0;
  }

  public int getNoStates()
  {
    return 23;
  }
}
