import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

public class InteractingStatesOptionsDialog extends JDialog implements ActionListener
{
  private boolean changed;
  private JCheckBox doBirthRandomCheckBox;
  private JCheckBox doSurviveRandomCheckBox;
  private JButton okButton;
  private JButton cancelButton;

  public InteractingStatesOptionsDialog(JFrame owner)
  {
    super(owner, "Options", true);
    doBirthRandomCheckBox = new JCheckBox("Birth Grid");
    doBirthRandomCheckBox.setSelected(true);
    doSurviveRandomCheckBox = new JCheckBox("Survive Grid");
    doSurviveRandomCheckBox.setSelected(false);
    JPanel controlPanel = new JPanel();
    controlPanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(), "New Rule Options"));
    controlPanel.setLayout(new GridLayout(2, 1, 5, 5));
    controlPanel.add(doBirthRandomCheckBox);
    controlPanel.add(doSurviveRandomCheckBox);
    okButton = new JButton("Ok");
    okButton.addActionListener(this);
    cancelButton = new JButton("Cancel");
    cancelButton.addActionListener(this);
    JPanel buttonPanel = new JPanel();
    buttonPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
    buttonPanel.add(okButton);
    buttonPanel.add(cancelButton);
    JPanel basePanel = new JPanel();
    basePanel.setBorder(BorderFactory.createLineBorder(basePanel.getBackground(), 15));
    basePanel.setLayout(new BorderLayout(0, 5));
    basePanel.add(controlPanel, BorderLayout.NORTH);
    basePanel.add(buttonPanel, BorderLayout.SOUTH);
    add(basePanel);
    pack();
    setResizable(false);
    basePanel.requestFocus();
    changed = false;
  }

  public void setData(InteractingStatesRule rule)
  {
    doBirthRandomCheckBox.setSelected(rule.getDoBirthRandom());
    doSurviveRandomCheckBox.setSelected(rule.getDoSurviveRandom());
  }

  public void getData(InteractingStatesRule rule)
  {
    rule.setDoBirthRandom(doBirthRandomCheckBox.isSelected());
    rule.setDoSurviveRandom(doSurviveRandomCheckBox.isSelected());
  }

  public boolean hasChanged()
  {
    return changed;
  }

  public void actionPerformed(ActionEvent e)
  {
    Object source = e.getSource();
    if (source == okButton)
    {
      setVisible(false);
      changed = true;
    }
    else if (source == cancelButton)
    {
      setVisible(false);
      changed = false;
    }
  }
}
