import java.awt.*;
import javax.swing.*;
import java.io.*;

class KnightShipsRule extends Rule
{
  public KnightShipsRule(JFrame mainFrame, SquareCell squareCell)
  {
    super(mainFrame, squareCell);
    this.mainFrame = mainFrame;
    this.squareCell = squareCell;
  }

  public void setNewRule()
  {
  }

  public void setOptions()
  {
  }

  public void setDefault()
  {
  }

  public void changeRule()
  {
  }

  public void writeRule(PrintWriter pw)
  {
    pw.println("#Rule = Knight Ships");
  }

  public void readRule(BufferedReader br)
  {
  }

  public int step(int row, int column)
  {
    int NW = squareCell.getNeighbor(row - 1, column - 1);
    int N  = squareCell.getNeighbor(row - 1, column    );
    int NE = squareCell.getNeighbor(row - 1, column + 1);
    int W  = squareCell.getNeighbor(row    , column - 1);
    int C  = squareCell.getNeighbor(row    , column    );
    int E  = squareCell.getNeighbor(row    , column + 1);
    int SW = squareCell.getNeighbor(row + 1, column - 1);
    int S  = squareCell.getNeighbor(row + 1, column    );
    int SE = squareCell.getNeighbor(row + 1, column + 1);

    int Sum = NW + N + NE + W + C + E + SW + S + SE;
    if (Sum == 0)
      return 0;

//  X = 2, Y = 1

    if ((C == 5) && (N == 2))
      return 0;
    if ((W == 2) && (SW == 5))
      return 1;
    if ((W == 5) && (NW == 2))
      return 6;

    if ((W == 5) && (S == 1))
      return 6;
    if ((C == 5) && (SE == 1))
      return 0;
    if ((C == 1) && (NW == 5))
      return 1;
    if ((W == 1) && (NW == 6))
      return 2;

    if ((N == 2) && (NW == 6))
      return 5;
    if ((C == 2) && (W == 6))
      return 1;
    if ((C == 6) && (E == 2))
      return 0;

    if ((N == 6) && (E == 1))
      return 6;
    if ((C == 1) && (NW == 6))
      return 5;
    if ((W == 6) && (S == 1))
      return 0;
    if ((C == 6) && (SE == 1))
      return 0;
    if ((N == 5) && (NW == 6))
      return 2;
    if ((C == 6) && (E == 5))
      return 0;

//  X = -2, Y = 1

    if ((C == 7) && (N == 2))
      return 0;
    if ((E == 2) && (SE == 7))
      return 1;
    if ((E == 7) && (NE == 2))
      return 8;

    if ((E == 7) && (S == 1))
      return 8;
    if ((C == 7) && (SW == 1))
      return 0;
    if ((C == 1) && (NE == 7))
      return 1;
    if ((E == 1) && (NE == 8))
      return 2;

    if ((N == 2) && (NE == 8))
      return 7;
    if ((C == 2) && (E == 8))
      return 1;
    if ((C == 8) && (W == 2))
      return 0;

    if ((N == 8) && (W == 1))
      return 8;
    if ((C == 1) && (NE == 8))
      return 7;
    if ((E == 8) && (S == 1))
      return 0;
    if ((C == 8) && (SW == 1))
      return 0;
    if ((N == 7) && (NE == 8))
      return 2;
    if ((C == 8) && (W == 7))
      return 0;

//  X = 2, Y = -1

    if ((C == 9) && (S == 1))
      return 0;
    if ((W == 1) && (NW == 9))
      return 2;
    if ((W == 9) && (SW == 1))
      return 10;

    if ((W == 9) && (N == 2))
      return 10;
    if ((C == 9) && (NE == 2))
      return 0;
    if ((C == 2) && (SW == 9))
      return 2;
    if ((W == 2) && (SW == 10))
      return 1;

    if ((S == 1) && (SW == 10))
      return 9;
    if ((C == 1) && (W == 10))
      return 2;
    if ((C == 10) && (E == 2))
      return 0;

    if ((S == 10) && (E == 2))
      return 10;
    if ((C == 2) && (SW == 10))
      return 9;
    if ((W == 10) && (N == 2))
      return 0;
    if ((C == 10) && (NE == 2))
      return 0;
    if ((S == 9) && (SW == 10))
      return 1;
    if ((C == 10) && (E == 9))
      return 0;

//  X = -2, Y = -1

    if ((C == 11) && (S == 1))
      return 0;
    if ((E == 1) && (NE == 11))
      return 2;
    if ((E == 11) && (SE == 1))
      return 12;

    if ((E == 11) && (N == 2))
      return 12;
    if ((C == 11) && (NW == 2))
      return 0;
    if ((C == 2) && (SE == 11))
      return 2;
    if ((E == 2) && (SE == 12))
      return 1;

    if ((S == 1) && (SE == 12))
      return 11;
    if ((C == 1) && (E == 12))
      return 2;
    if ((C == 12) && (W == 2))
      return 0;

    if ((S == 12) && (W == 2))
      return 12;
    if ((C == 2) && (SE == 12))
      return 11;
    if ((E == 12) && (N == 2))
      return 0;
    if ((C == 12) && (NW == 2))
      return 0;
    if ((S == 11) && (SE == 12))
      return 1;
    if ((C == 12) && (W == 11))
      return 0;

//  X = 1,  Y = -2

    if ((C == 14) && (W == 4))
      return 0;
    if ((S == 4) && (SE == 14))
      return 3;
    if ((S == 14) && (SW == 4))
      return 13;

    if ((S == 14) && (E == 3))
      return 13;
    if ((C == 14) && (NE == 3))
      return 0;
    if ((C == 3) && (SW == 14))
      return 3;
    if ((S == 3) && (SW == 13))
      return 4;

    if ((W == 4) && (SW == 13))
      return 14;
    if ((C == 4) && (S == 13))
      return 3;
    if ((C == 13) && (N == 4))
      return 0;

    if ((N == 3) && (W == 13))
      return 13;
    if ((C == 3) && (SW == 13))
      return 14;
    if ((C == 13) && (NE == 3))
      return 0;
    if ((E == 3) && (S == 13))
      return 0;
    if ((W == 14) && (SW == 13))
      return 4;
    if ((C == 13) && (N == 14))
      return 0;

//  X = 1,  Y = 2

    if ((C == 16) && (W == 4))
      return 0;
    if ((N == 4) && (NE == 16))
      return 3;
    if ((N == 16) && (NW == 4))
      return 15;

    if ((N == 16) && (E == 3))
      return 15;
    if ((C == 16) && (SE == 3))
      return 0;
    if ((C == 3) && (NW == 16))
      return 3;
    if ((N == 3) && (NW == 15))
      return 4;

    if ((W == 4) && (NW == 15))
      return 16;
    if ((C == 4) && (N == 15))
      return 3;
    if ((C == 15) && (S == 4))
      return 0;

    if ((S == 3) && (W == 15))
      return 15;
    if ((C == 3) && (NW == 15))
      return 16;
    if ((C == 15) && (SE == 3))
      return 0;
    if ((E == 3) && (N == 15))
      return 0;
    if ((W == 16) && (NW == 15))
      return 4;
    if ((C == 15) && (S == 16))
      return 0;

//  X = -1,  Y = 2

    if ((C == 18) && (E == 3))
      return 0;
    if ((N == 3) && (NW == 18))
      return 4;
    if ((N == 18) && (NE == 3))
      return 17;

    if ((N == 18) && (W == 4))
      return 17;
    if ((C == 18) && (SW == 4))
      return 0;
    if ((C == 4) && (NE == 18))
      return 4;
    if ((N == 4) && (NE == 17))
      return 3;

    if ((E == 3) && (NE == 17))
      return 18;
    if ((C == 3) && (N == 17))
      return 4;
    if ((C == 17) && (S == 3))
      return 0;

    if ((S == 4) && (E == 17))
      return 17;
    if ((C == 4) && (NE == 17))
      return 18;
    if ((C == 17) && (SW == 4))
      return 0;
    if ((W == 4) && (N == 17))
      return 0;
    if ((E == 18) && (NE == 17))
      return 3;
    if ((C == 17) && (S == 18))
      return 0;

//  X = -1,  Y = -2

    if ((C == 20) && (E == 3))
      return 0;
    if ((S == 3) && (SW == 20))
      return 4;
    if ((S == 20) && (SE == 3))
      return 19;

    if ((S == 20) && (W == 4))
      return 19;
    if ((C == 20) && (NW == 4))
      return 0;
    if ((C == 4) && (SE == 20))
      return 4;
    if ((S == 4) && (SE == 19))
      return 3;

    if ((E == 3) && (SE == 19))
      return 20;
    if ((C == 3) && (S == 19))
      return 4;
    if ((C == 19) && (N == 3))
      return 0;

    if ((N == 4) && (E == 19))
      return 19;
    if ((C == 4) && (SE == 19))
      return 20;
    if ((C == 19) && (NW == 4))
      return 0;
    if ((W == 4) && (S == 19))
      return 0;
    if ((E == 20) && (SE == 19))
      return 3;
    if ((C == 19) && (N == 20))
      return 0;

    if ((C == 1) && (N == 21))
      return 2;
    if ((C == 2) && (S == 21))
      return 1;
    if ((W == 21) && (NW == 2))
      return 2;
    if ((W == 2) && (SW == 21))
      return 5;
    if ((C == 1) && (N == 22))
      return 2;
    if ((C == 2) && (S == 22))
      return 1;
    if ((W == 22) && (SW == 1))
      return 5;

    if ((C == 0) && (S == 1))
      return 1;
    if ((C == 0) && (N == 2))
      return 2;
    if ((C == 0) && (E == 3))
      return 3;
    if ((C == 0) && (W == 4))
      return 4;

    if (C == 5)
      return 5;
    if (C == 6)
      return 6;
    if (C == 7)
      return 7;
    if (C == 8)
      return 8;
    if (C == 9)
      return 9;
    if (C == 10)
      return 10;
    if (C == 11)
      return 11;
    if (C == 12)
      return 12;
    if (C == 13)
      return 13;
    if (C == 14)
      return 14;
    if (C == 15)
      return 15;
    if (C == 16)
      return 16;
    if (C == 17)
      return 17;
    if (C == 18)
      return 18;
    if (C == 19)
      return 19;
    if (C == 20)
      return 20;
    if (C == 21)
      return 21;
    if (C == 22)
      return 22;

    return 0;
  }

  public int getNoStates()
  {
    return 23;
  }
}
